import os
import gzip
import shutil



def unzip_extract():
    """
    A function which checks all the .json.gz downloaded files in the current dir.
    if the extension matches (.json.gz) extracts them with the same name .json.
    :return:
    """
    print(f"Entering unzip_extract() function\n")
   # Unzip the .json.gz
    path_of_the_directory = './'
    ext = ('.gz')
    for files in os.listdir(path_of_the_directory):
        print(f"Working on File --> {files}")
        if files.endswith(ext):
            name = files[2:-3]
            print("----------------------------------WORKING---------------------------------------")
            # Extracting json.gz to .json and then converting .json to .csv and saving with the name
            with gzip.open(files, 'rb') as f_in:
                print("EXTRACTING...")
                with open(name, 'wb') as f_out:
                    shutil.copyfileobj(f_in,f_out)
                print(f"\nDone with EXTRACTING the file \n{files} \n \t\t\t and is saved as \n{name} in csv folder\n")
                print(f"DELETING the extracted file...") 
                os.remove(files)
                print("Done deleting the file")
        else:
            if files.endswith('.json') or files.endswith('.txt') or files.endswith('.py') or files=="json_files" or files=="csv":                
                print(f"file {files} is in .json, .py, .txt or a dir (json_files) NOT EXTRACTABLE..")
            else:
                print(f"Deleting useless files {files} DELETED...")
                os.remove(files)
                print("Done deleting the file")
            
    print(f"Done with unzip_extract() function") 



if __name__ == "__main__":
    unzip_extract()
    # #read the path
    # file_path = "./"
    # #list all the files from the directory
    # files = os.listdir(file_path)
    # for file in files:
    #     unzip_extract(file)
    #     print(f"File --> {file} Done\n")
